local add = 0;
local aaa = 0;

memory.registerexec(0x185BC0,1, function(address,size)
	add=memory.getregister("d0");
	aaa=memory.getregister("a0");
end)

function myhex(hx)
	local str = string.format("%04X", hx);
	return string.sub(str,0,2)..'\n'..string.sub(str,3,4);
end

gui.register( function ()
	local x = memory.readword(0xFF005A);
	local y = memory.readword(0xFF005C)-0xE0;
	local a1 = memory.readlong(0xFF00FC);
	local ad4 = math.floor(memory.readbyte(memory.readword(a1+8)+8)/2);
	local word_FF0064 = 0xA0 + memory.readword(0xFF0064) - 0x180 - y;
	--local word_FF00EC = memory.readbyte(a1+5) + 0x10 + memory.readword(0xFF00EC) - 0x170 - y;
	local word_FF00EC = memory.readbyte(a1+5) + 0x10 + memory.readword(0xFF00EC) - 0x140 - y;
	local word_FF0016 = memory.readword(0xFF0016);
	local ys = (word_FF0064 % 16);
	word_FF0064 = word_FF0064 - ys;
	word_FF00EC = word_FF00EC - ys;
	for i = 0, 15, 1 do
		local a0 = memory.readlong(0xFFB544 + word_FF0064*4);
		local a02 = memory.readlong(0xFFB544 + word_FF00EC*4);
		local word_FF0062 = memory.readword(0xFF0062) - x;
		--local word_FF00EA = ad4 + memory.readbyte(a1+2) + memory.readword(0xFF0062) - x - 0x70;
		local word_FF00EA = memory.readbyte(a1+2) + memory.readword(0xFF00EA) - x - 0x60;
		local xs = (word_FF0062 % 16);
		word_FF0062 = word_FF0062 - xs; 
		word_FF00EA = word_FF00EA - xs; 
		for j = 0, 20, 1 do
			local c0 = a0 + (word_FF0062 + 0x10) / 8 + word_FF0016;
			local c02 = a02 + math.floor(word_FF00EA/16) * 2 - word_FF0016;
			local d0 = math.floor(memory.readword(c0)/2);
			local d02 = math.floor(memory.readword(c02)/2);
			local t = memory.readword(0xFFD144+d0);
			local t2 = memory.readbyte(0xFFD144+d02+2);
			if (t ~= 0) then
				gui.text (j*16 - xs, i*16 - ys, myhex(t), 'blue');
			end
			if (t2 ~= 0) then
				gui.text (j*16 - xs+8, i*16 - ys, string.format("%02X",t2), 'red');
			end
			word_FF0062 = word_FF0062 + 16;
			word_FF00EA = word_FF00EA + 16;
		end
		word_FF0064 = word_FF0064 + 16;
		word_FF00EC = word_FF00EC + 16;
	end
	--gui.text (x, y, string.format("%04X %06X", add, aaa), 'blue');
end)